apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ include "loki.readFullname" . }}
  labels:
    {{- include "loki.readLabels" . | nindent 4 }}
    app.kubernetes.io/part-of: memberlist
spec:
  replicas: {{ .Values.read.replicas }}
  podManagementPolicy: Parallel
  updateStrategy:
    rollingUpdate:
      partition: 0
  serviceName: {{ include "loki.readFullname" . }}-headless
  revisionHistoryLimit: {{ .Values.loki.revisionHistoryLimit }}
  selector:
    matchLabels:
      {{- include "loki.readSelectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations:
        {{- if .Values.vault.enabled }}
        {{- include "loki.vault" . | nindent 8 }}
        {{- end }}
          checksum/config: {{ include (print .Template.BasePath "/configmap.yaml") . | sha256sum }}
        {{- with .Values.loki.podAnnotations }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
        {{- with .Values.read.podAnnotations }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
      labels:
        {{- include "loki.readSelectorLabels" . | nindent 8 }}
        app.kubernetes.io/part-of: memberlist
    spec:
      serviceAccountName: {{ include "loki.serviceAccountName" . }}
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- include "loki.readPriorityClassName" . | nindent 6 }}
      securityContext:
        {{- toYaml .Values.loki.podSecurityContext | nindent 8 }}
      terminationGracePeriodSeconds: {{ .Values.read.terminationGracePeriodSeconds }}
      containers:
        - name: loki
          image: {{ include "loki.readImage" . }}
          imagePullPolicy: {{ .Values.loki.image.pullPolicy }}
          {{- if .Values.vault.enabled }}
          command: ["/bin/sh"]
          args:
            - "-c"
            - ". /vault/secrets/secretfile ; /usr/bin/loki -config.expand-env=true -config.file=/etc/loki/config/config.yaml -target=read"
            {{- with .Values.read.extraArgs }}
            {{- toYaml . | nindent 12 }}
            {{- end }}
          {{- else }}
          command: ["/bin/sh"]
          args:
            - "-c"
            - "/usr/bin/loki -config.file=/etc/loki/config/config.yaml -target=read"
            {{- with .Values.read.extraArgs }}
            {{- toYaml . | nindent 12 }}
            {{- end }}
          {{- end}}
          ports:
            - name: http
              containerPort: 3100
              protocol: TCP
            - name: grpc
              containerPort: 9095
              protocol: TCP
            - name: http-memberlist
              containerPort: 7946
              protocol: TCP
          {{- with .Values.read.extraEnv }}
          env:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with .Values.read.extraEnvFrom }}
          envFrom:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          securityContext:
            {{- toYaml .Values.loki.containerSecurityContext | nindent 12 }}
          readinessProbe:
            {{- toYaml .Values.loki.readinessProbe | nindent 12 }}
          volumeMounts:
            - name: config
              mountPath: /etc/loki/config
            - name: data
              mountPath: /var/loki
            {{- with .Values.read.extraVolumeMounts }}
            {{- toYaml . | nindent 12 }}
            {{- end }}
          resources:
            {{- toYaml .Values.read.resources | nindent 12 }}
      {{- with .Values.read.affinity }}
      affinity:
        {{- tpl . $ | nindent 8 }}
      {{- end }}
      {{- with .Values.read.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.read.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      volumes:
        - name: config
          {{- if .Values.loki.existingSecretForConfig }}
          secret:
            secretName: {{ .Values.loki.existingSecretForConfig }}
          {{- else }}
          configMap:
            name: {{ include "loki.fullname" . }}
          {{- end }}
        {{- with .Values.read.extraVolumes }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
  volumeClaimTemplates:
    - metadata:
        name: data
      spec:
        accessModes:
          - ReadWriteOnce
        {{- with .Values.read.persistence.storageClass }}
        storageClassName: {{ if (eq "-" .) }}""{{ else }}{{ . }}{{ end }}
        {{- end }}
        resources:
          requests:
            storage: {{ .Values.read.persistence.size | quote }}
